diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-phy.cc ns-3.43/src/wifi/model/wifi-phy.cc
--- ns-3.42/src/wifi/model/wifi-phy.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-phy.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
@@ -30,6 +19,7 @@
 #include "wifi-radio-energy-model.h"
 #include "wifi-utils.h"
 
+#include "ns3/attribute-container.h"
 #include "ns3/channel.h"
 #include "ns3/dsss-phy.h"
 #include "ns3/eht-phy.h" //also includes OFDM, HT, VHT and HE
@@ -46,6 +36,7 @@
 #include "ns3/vht-configuration.h"
 
 #include <algorithm>
+#include <numeric>
 
 #undef NS_LOG_APPEND_CONTEXT
 #define NS_LOG_APPEND_CONTEXT                                                                      \
@@ -80,9 +71,11 @@
                           MakePointerChecker<Channel>())
             .AddAttribute(
                 "ChannelSettings",
-                "Tuple {channel number, channel width (MHz), PHY band, primary20 index} "
-                "describing the settings of the operating channel. The primary20 index is "
-                "the index of the primary 20 MHz channel within the operating channel "
+                "A vector of tuple {channel number, channel width (MHz), PHY band, primary20 "
+                "index} "
+                "describing the settings of the operating channel for each segment. "
+                "The primary20 index (only the value set for the first segment is used) "
+                "is the index of the primary 20 MHz channel within the operating channel "
                 "(0 indicates the 20 MHz subchannel with the lowest center frequency) and "
                 "is only valid if the width of the operating channel is a multiple of 20 MHz. "
                 "If the standard for this object has not been set yet, the value of this "
@@ -91,21 +84,21 @@
                 "band for the configured standard is used. If the channel width and the "
                 "channel number are both 0, the default channel width for the configured "
                 "standard and band are used. If the channel number is 0, the default "
-                "channel number for the configured standard, band and channel width is used."
+                "channel number for the configured standard, band and channel width is used. "
                 "Note that the channel width can be left unspecified (0) if the channel "
                 "number uniquely identify a frequency channel for the given standard and band.",
                 StringValue("{0, 0, BAND_UNSPECIFIED, 0}"),
-                MakeTupleAccessor<UintegerValue,
-                                  UintegerValue,
-                                  EnumValue<WifiPhyBand>,
-                                  UintegerValue>((void(WifiPhy::*)(const ChannelTuple&)) &
-                                                 WifiPhy::SetOperatingChannel),
-                MakeTupleChecker<UintegerValue,
-                                 UintegerValue,
-                                 EnumValue<WifiPhyBand>,
-                                 UintegerValue>(
+                MakeAttributeContainerAccessor<
+                    TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
+                    ';'>((void(WifiPhy::*)(const ChannelSegments&)) & WifiPhy::SetOperatingChannel),
+                MakeAttributeContainerChecker<
+                    TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
+                    ';'>(MakeTupleChecker<UintegerValue,
+                                          UintegerValue,
+                                          EnumValue<WifiPhyBand>,
+                                          UintegerValue>(
                     MakeUintegerChecker<uint8_t>(0, 233),
-                    MakeUintegerChecker<uint16_t>(0, 160),
+                    MakeUintegerChecker<MHz_u>(0, 160),
                     MakeEnumChecker(WifiPhyBand::WIFI_PHY_BAND_2_4GHZ,
                                     "BAND_2_4GHZ",
                                     WifiPhyBand::WIFI_PHY_BAND_5GHZ,
@@ -114,13 +107,13 @@
                                     "BAND_6GHZ",
                                     WifiPhyBand::WIFI_PHY_BAND_UNSPECIFIED,
                                     "BAND_UNSPECIFIED"),
-                    MakeUintegerChecker<uint8_t>(0, 7)))
+                    MakeUintegerChecker<uint8_t>(0, 7))))
             .AddAttribute("Frequency",
                           "The center frequency (MHz) of the current operating channel.",
                           TypeId::ATTR_GET,
                           UintegerValue(0),
                           MakeUintegerAccessor(&WifiPhy::GetFrequency),
-                          MakeUintegerChecker<uint16_t>())
+                          MakeUintegerChecker<int64_t>())
             .AddAttribute("ChannelNumber",
                           "The channel number of the current operating channel.",
                           TypeId::ATTR_GET,
@@ -129,11 +122,12 @@
                           MakeUintegerChecker<uint8_t>(0, 233))
             .AddAttribute(
                 "ChannelWidth",
-                "The width in MHz of the current operating channel (5, 10, 20, 22, 40, 80 or 160).",
+                "The width in MHz of the current operating channel (5, 10, 20, 22, 40, 80 or 160). "
+                "If 80+80MHz is used, this corresponds to the total channel width, hence 160 MHz.",
                 TypeId::ATTR_GET,
                 UintegerValue(0),
                 MakeUintegerAccessor(&WifiPhy::GetChannelWidth),
-                MakeUintegerChecker<uint16_t>(5, 160))
+                MakeUintegerChecker<MHz_u>(5, 160))
             .AddAttribute(
                 "Primary20MHzIndex",
                 "The index of the primary 20 MHz channel within the current operating channel "
@@ -154,7 +148,7 @@
                 "scaled to match the width of the received signal.",
                 DoubleValue(-101.0),
                 MakeDoubleAccessor(&WifiPhy::SetRxSensitivity, &WifiPhy::GetRxSensitivity),
-                MakeDoubleChecker<double>())
+                MakeDoubleChecker<dBm_u>())
             .AddAttribute(
                 "CcaEdThreshold",
                 "The energy of all received signals should be higher than "
@@ -162,7 +156,7 @@
                 "to declare CCA BUSY state.",
                 DoubleValue(-62.0),
                 MakeDoubleAccessor(&WifiPhy::SetCcaEdThreshold, &WifiPhy::GetCcaEdThreshold),
-                MakeDoubleChecker<double>())
+                MakeDoubleChecker<dBm_u>())
             .AddAttribute("CcaSensitivity",
                           "The energy of a received wifi signal should be higher than "
                           "this threshold (dBm) in the primary channel to allow the PHY layer "
@@ -170,17 +164,17 @@
                           DoubleValue(-82.0),
                           MakeDoubleAccessor(&WifiPhy::SetCcaSensitivityThreshold,
                                              &WifiPhy::GetCcaSensitivityThreshold),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<dBm_u>())
             .AddAttribute("TxGain",
                           "Transmission gain (dB).",
                           DoubleValue(0.0),
                           MakeDoubleAccessor(&WifiPhy::SetTxGain, &WifiPhy::GetTxGain),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<dB_u>())
             .AddAttribute("RxGain",
                           "Reception gain (dB).",
                           DoubleValue(0.0),
                           MakeDoubleAccessor(&WifiPhy::SetRxGain, &WifiPhy::GetRxGain),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<dB_u>())
             .AddAttribute("TxPowerLevels",
                           "Number of transmission power levels available between "
                           "TxPowerStart and TxPowerEnd included.",
@@ -191,12 +185,12 @@
                           "Maximum available transmission level (dBm).",
                           DoubleValue(16.0206),
                           MakeDoubleAccessor(&WifiPhy::SetTxPowerEnd, &WifiPhy::GetTxPowerEnd),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<dBm_u>())
             .AddAttribute("TxPowerStart",
                           "Minimum available transmission level (dBm).",
                           DoubleValue(16.0206),
                           MakeDoubleAccessor(&WifiPhy::SetTxPowerStart, &WifiPhy::GetTxPowerStart),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<dBm_u>())
             .AddAttribute(
                 "RxNoiseFigure",
                 "Loss (dB) in the Signal-to-Noise-Ratio due to non-idealities in the receiver."
@@ -207,7 +201,7 @@
                 " are connected to sources at the standard noise temperature T0 (usually 290 K)\".",
                 DoubleValue(7),
                 MakeDoubleAccessor(&WifiPhy::SetRxNoiseFigure),
-                MakeDoubleChecker<double>())
+                MakeDoubleChecker<dB_u>())
             .AddAttribute("State",
                           "The state of the PHY layer.",
                           PointerValue(),
@@ -298,7 +292,13 @@
                           "limit (in dBm/MHz) set by regulators.",
                           DoubleValue(100.0), // set to a high value so as to have no effect
                           MakeDoubleAccessor(&WifiPhy::m_powerDensityLimit),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<dBm_per_MHz_u>())
+            .AddAttribute("NotifyMacHdrRxEnd",
+                          "Whether the PHY is capable of notifying the MAC about the end of "
+                          "the reception of the MAC header of every MPDU.",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&WifiPhy::m_notifyRxMacHeaderEnd),
+                          MakeBooleanChecker())
             .AddTraceSource("PhyTxBegin",
                             "Trace source indicating a packet "
                             "has begun transmitting over the channel medium",
@@ -330,6 +330,11 @@
                             "payload of a PPDU has begun",
                             MakeTraceSourceAccessor(&WifiPhy::m_phyRxPayloadBeginTrace),
                             "ns3::WifiPhy::PhyRxPayloadBeginTracedCallback")
+            .AddTraceSource("PhyRxMacHeaderEnd",
+                            "Trace source indicating the MAC header of an MPDU has been "
+                            "completely received.",
+                            MakeTraceSourceAccessor(&WifiPhy::m_phyRxMacHeaderEndTrace),
+                            "ns3::WifiPhy::PhyRxMacHeaderEndTracedCallback")
             .AddTraceSource("PhyRxEnd",
                             "Trace source indicating a packet "
                             "has been completely received from the channel medium "
@@ -479,6 +484,11 @@
 WifiPhy::RegisterListener(const std::shared_ptr<WifiPhyListener>& listener)
 {
     m_state->RegisterListener(listener);
+    if (IsInitialized())
+    {
+        // provide CCA busy information upon registering a PHY listener
+        SwitchMaybeToCcaBusy(nullptr);
+    }
 }
 
 void
@@ -494,79 +504,79 @@
 }
 
 void
-WifiPhy::SetRxSensitivity(double threshold)
+WifiPhy::SetRxSensitivity(dBm_u threshold)
 {
     NS_LOG_FUNCTION(this << threshold);
-    m_rxSensitivityDbm = threshold;
+    m_rxSensitivity = threshold;
 }
 
-double
+dBm_u
 WifiPhy::GetRxSensitivity() const
 {
-    return m_rxSensitivityDbm;
+    return m_rxSensitivity;
 }
 
 void
-WifiPhy::SetCcaEdThreshold(double threshold)
+WifiPhy::SetCcaEdThreshold(dBm_u threshold)
 {
     NS_LOG_FUNCTION(this << threshold);
-    m_ccaEdThresholdW = DbmToW(threshold);
+    m_ccaEdThreshold = threshold;
 }
 
-double
+dBm_u
 WifiPhy::GetCcaEdThreshold() const
 {
-    return WToDbm(m_ccaEdThresholdW);
+    return m_ccaEdThreshold;
 }
 
 void
-WifiPhy::SetCcaSensitivityThreshold(double threshold)
+WifiPhy::SetCcaSensitivityThreshold(dBm_u threshold)
 {
     NS_LOG_FUNCTION(this << threshold);
-    m_ccaSensitivityThresholdW = DbmToW(threshold);
+    m_ccaSensitivityThreshold = threshold;
 }
 
-double
+dBm_u
 WifiPhy::GetCcaSensitivityThreshold() const
 {
-    return WToDbm(m_ccaSensitivityThresholdW);
+    return m_ccaSensitivityThreshold;
 }
 
 void
-WifiPhy::SetRxNoiseFigure(double noiseFigureDb)
+WifiPhy::SetRxNoiseFigure(dB_u noiseFigure)
 {
-    NS_LOG_FUNCTION(this << noiseFigureDb);
+    NS_LOG_FUNCTION(this << noiseFigure);
     if (m_interference)
     {
-        m_interference->SetNoiseFigure(DbToRatio(noiseFigureDb));
+        m_interference->SetNoiseFigure(DbToRatio(noiseFigure));
     }
-    m_noiseFigureDb = noiseFigureDb;
+    m_noiseFigure = noiseFigure;
 }
 
 void
-WifiPhy::SetTxPowerStart(double start)
+WifiPhy::SetTxPowerStart(dBm_u start)
 {
     NS_LOG_FUNCTION(this << start);
-    m_txPowerBaseDbm = start;
+    m_txPowerBase = start;
 }
 
-double
+dBm_u
 WifiPhy::GetTxPowerStart() const
 {
-    return m_txPowerBaseDbm;
+    return m_txPowerBase;
 }
 
 void
-WifiPhy::SetTxPowerEnd(double end)
+WifiPhy::SetTxPowerEnd(dBm_u end)
 {
     NS_LOG_FUNCTION(this << end);
-    m_txPowerEndDbm = end;
+    m_txPowerEnd = end;
 }
 
-double
+dBm_u
 WifiPhy::GetTxPowerEnd() const
 {
-    return m_txPowerEndDbm;
+    return m_txPowerEnd;
 }
 
 void
@@ -583,29 +593,29 @@
 }
 
 void
-WifiPhy::SetTxGain(double gain)
+WifiPhy::SetTxGain(dB_u gain)
 {
     NS_LOG_FUNCTION(this << gain);
-    m_txGainDb = gain;
+    m_txGain = gain;
 }
 
-double
+dB_u
 WifiPhy::GetTxGain() const
 {
-    return m_txGainDb;
+    return m_txGain;
 }
 
 void
-WifiPhy::SetRxGain(double gain)
+WifiPhy::SetRxGain(dB_u gain)
 {
     NS_LOG_FUNCTION(this << gain);
-    m_rxGainDb = gain;
+    m_rxGain = gain;
 }
 
-double
+dB_u
 WifiPhy::GetRxGain() const
 {
-    return m_rxGainDb;
+    return m_rxGain;
 }
 
 void
@@ -663,7 +673,7 @@
 {
     NS_LOG_FUNCTION(this << helper);
     m_interference = helper;
-    m_interference->SetNoiseFigure(DbToRatio(m_noiseFigureDb));
+    m_interference->SetNoiseFigure(DbToRatio(m_noiseFigure));
     m_interference->SetNumberOfReceiveAntennas(m_numberOfAntennas);
 }
 
@@ -700,21 +710,21 @@
     m_wifiRadioEnergyModel = wifiRadioEnergyModel;
 }
 
-double
-WifiPhy::GetPowerDbm(uint8_t power) const
+dBm_u
+WifiPhy::GetPower(uint8_t powerLevel) const
 {
-    NS_ASSERT(m_txPowerBaseDbm <= m_txPowerEndDbm);
+    NS_ASSERT(m_txPowerBase <= m_txPowerEnd);
     NS_ASSERT(m_nTxPower > 0);
-    double dbm;
+    dBm_u dbm;
     if (m_nTxPower > 1)
     {
-        dbm = m_txPowerBaseDbm + power * (m_txPowerEndDbm - m_txPowerBaseDbm) / (m_nTxPower - 1);
+        dbm = m_txPowerBase + powerLevel * (m_txPowerEnd - m_txPowerBase) / (m_nTxPower - 1);
     }
     else
     {
-        NS_ASSERT_MSG(m_txPowerBaseDbm == m_txPowerEndDbm,
+        NS_ASSERT_MSG(m_txPowerBase == m_txPowerEnd,
                       "cannot have TxPowerEnd != TxPowerStart with TxPowerLevels == 1");
-        dbm = m_txPowerBaseDbm;
+        dbm = m_txPowerBase;
     }
     return dbm;
 }
@@ -1067,7 +1077,7 @@
     return m_operatingChannel;
 }
 
-uint16_t
+MHz_u
 WifiPhy::GetFrequency() const
 {
     return m_operatingChannel.GetFrequency();
@@ -1079,10 +1089,10 @@
     return m_operatingChannel.GetNumber();
 }
 
-uint16_t
+MHz_u
 WifiPhy::GetChannelWidth() const
 {
-    return m_operatingChannel.GetWidth();
+    return m_operatingChannel.GetTotalWidth();
 }
 
 uint8_t
@@ -1103,8 +1113,8 @@
     return m_fixedPhyBand;
 }
 
-uint16_t
-WifiPhy::GetTxBandwidth(WifiMode mode, uint16_t maxAllowedWidth) const
+MHz_u
+WifiPhy::GetTxBandwidth(WifiMode mode, MHz_u maxAllowedWidth) const
 {
     auto modulation = mode.GetModulationClass();
     if (modulation == WIFI_MOD_CLASS_DSSS || modulation == WIFI_MOD_CLASS_HR_DSSS)
@@ -1119,22 +1129,32 @@
 WifiPhy::SetOperatingChannel(const WifiPhyOperatingChannel& channel)
 {
     NS_LOG_FUNCTION(this << channel);
-    WifiPhy::ChannelTuple tuple(channel.GetNumber(),
-                                channel.GetWidth(),
-                                channel.GetPhyBand(),
-                                channel.GetPrimaryChannelIndex(20));
-    SetOperatingChannel(tuple);
+    ChannelSegments segments{};
+    for (std::size_t segmentId = 0; segmentId < channel.GetNSegments(); ++segmentId)
+    {
+        segments.emplace_back(channel.GetNumber(segmentId),
+                              channel.GetWidth(segmentId),
+                              channel.GetPhyBand(),
+                              channel.GetPrimaryChannelIndex(20));
+    }
+    SetOperatingChannel(segments);
 }
 
 void
-WifiPhy::SetOperatingChannel(const ChannelTuple& channelTuple)
+WifiPhy::SetOperatingChannel(const ChannelTuple& tuple)
 {
-    // the generic operator<< for tuples does not give a pretty result
-    NS_LOG_FUNCTION(this << +std::get<0>(channelTuple) << std::get<1>(channelTuple)
-                         << static_cast<WifiPhyBand>(std::get<2>(channelTuple))
-                         << +std::get<3>(channelTuple));
+    SetOperatingChannel(ChannelSegments{tuple});
+}
 
-    m_channelSettings = channelTuple;
+void
+WifiPhy::SetOperatingChannel(const ChannelSegments& channelSegments)
+{
+    NS_LOG_FUNCTION(this << +std::get<0>(channelSegments.front())
+                         << std::get<1>(channelSegments.front())
+                         << static_cast<WifiPhyBand>(std::get<2>(channelSegments.front()))
+                         << +std::get<3>(channelSegments.front()));
+
+    m_channelSettings = channelSegments;
 
     if (m_standard == WIFI_STANDARD_UNSPECIFIED)
     {
@@ -1153,8 +1173,8 @@
         if (delay.value().IsStrictlyPositive())
         {
             // switching channel has been postponed
-            void (WifiPhy::*fp)(const ChannelTuple&) = &WifiPhy::SetOperatingChannel;
-            Simulator::Schedule(delay.value(), fp, this, channelTuple);
+            void (WifiPhy::*fp)(const ChannelSegments&) = &WifiPhy::SetOperatingChannel;
+            Simulator::Schedule(delay.value(), fp, this, channelSegments);
             return;
         }
     }
@@ -1173,7 +1193,6 @@
         return Seconds(0);
     }
 
-    NS_ASSERT(!IsStateSwitching());
     std::optional<Time> delay;
     switch (m_state->GetState())
     {
@@ -1191,6 +1210,9 @@
         Reset();
         delay = Seconds(0);
         break;
+    case WifiPhyState::SWITCHING:
+        delay = Seconds(0);
+        break;
     case WifiPhyState::SLEEP:
         NS_LOG_DEBUG("channel switching ignored in sleep mode");
         break;
@@ -1211,8 +1233,9 @@
     m_channelAccessRequested = false;
 
     // Update unspecified parameters with default values
+    std::optional<uint8_t> prevChannelNumber{};
+    for (auto& [number, width, band, primary20] : m_channelSettings)
     {
-        auto& [number, width, band, primary20] = m_channelSettings;
         if (band == WIFI_PHY_BAND_UNSPECIFIED)
         {
             band = GetDefaultPhyBand(m_standard);
@@ -1226,22 +1249,39 @@
             number =
                 WifiPhyOperatingChannel::GetDefaultChannelNumber(width,
                                                                  m_standard,
-                                                                 static_cast<WifiPhyBand>(band));
+                                                                 static_cast<WifiPhyBand>(band),
+                                                                 prevChannelNumber);
         }
+        prevChannelNumber = number;
     }
 
     // We need to call SetStandard if this is the first time we set a channel or we
     // are changing PHY band. Checking if the new PHY band is different than the
     // previous one covers both cases because initially the PHY band is unspecified
-    bool changingPhyBand = (static_cast<WifiPhyBand>(std::get<2>(m_channelSettings)) != m_band);
+    bool changingPhyBand =
+        (static_cast<WifiPhyBand>(std::get<2>(m_channelSettings.front())) != m_band);
 
     NS_ABORT_MSG_IF(IsInitialized() && m_fixedPhyBand && changingPhyBand,
                     "Trying to change PHY band while prohibited.");
 
-    m_band = static_cast<WifiPhyBand>(std::get<2>(m_channelSettings));
+    m_band = static_cast<WifiPhyBand>(std::get<2>(m_channelSettings.front()));
+
+    NS_LOG_DEBUG("switching channel");
+    std::vector<FrequencyChannelInfo> segments{};
+    std::transform(m_channelSettings.cbegin(),
+                   m_channelSettings.cend(),
+                   std::back_inserter(segments),
+                   [this](const auto& channelTuple) {
+                       return FrequencyChannelInfo{std::get<0>(channelTuple),
+                                                   0,
+                                                   std::get<1>(channelTuple),
+                                                   m_band};
+                   });
+    m_operatingChannel.Set(segments, m_standard);
+    m_operatingChannel.SetPrimary20Index(std::get<3>(m_channelSettings.front()));
 
     // check that the channel width is supported
-    uint16_t chWidth = std::get<1>(m_channelSettings);
+    const auto chWidth = GetChannelWidth();
 
     if (m_device)
     {
@@ -1262,15 +1302,13 @@
         }
     }
 
-    NS_LOG_DEBUG("switching channel");
-    m_operatingChannel.Set(std::get<0>(m_channelSettings), 0, chWidth, m_standard, m_band);
-    m_operatingChannel.SetPrimary20Index(std::get<3>(m_channelSettings));
-
     if (changingPhyBand)
     {
         ConfigureStandard(m_standard);
     }
 
+    FinalizeChannelSwitch();
+
     if (IsInitialized())
     {
         // notify channel switching
@@ -1282,6 +1320,7 @@
          * state are added to the event list and are employed later to figure
          * out the state of the medium after the switching.
          */
+        SwitchMaybeToCcaBusy(nullptr);
     }
 }
 
@@ -1394,13 +1433,7 @@
         // The PHY object may be in CCA_BUSY state because it is receiving a preamble. Cancel
         // preamble events before switching to sleep state
         Reset();
-        // It may happen that we request to switch to sleep at the same time the reception of
-        // a PPDU ends. In such a case, WifiPhyStateHelper::GetState() does not return RX
-        // (m_endRx equals now), we get here and set the state to SLEEP. However,
-        // WifiPhyStateHelper::DoSwitchFromRx() may be called after this function (at the same
-        // simulation time), thus hitting the assert that checks that the state is IDLE or
-        // CCA_BUSY.
-        Simulator::ScheduleNow(&WifiPhyStateHelper::SwitchToSleep, m_state);
+        m_state->SwitchToSleep();
         break;
     case WifiPhyState::SLEEP:
         NS_LOG_DEBUG("already in sleep mode");
@@ -1556,7 +1589,7 @@
 }
 
 Time
-WifiPhy::CalculateTxDuration(WifiConstPsduMap psduMap,
+WifiPhy::CalculateTxDuration(const WifiConstPsduMap& psduMap,
                              const WifiTxVector& txVector,
                              WifiPhyBand band)
 {
@@ -1571,7 +1604,7 @@
 }
 
 void
-WifiPhy::NotifyTxBegin(WifiConstPsduMap psdus, double txPowerW)
+WifiPhy::NotifyTxBegin(const WifiConstPsduMap& psdus, Watt_u txPower)
 {
     if (!m_phyTxBeginTrace.IsEmpty())
     {
@@ -1579,14 +1612,14 @@
         {
             for (auto& mpdu : *PeekPointer(psdu.second))
             {
-                m_phyTxBeginTrace(mpdu->GetProtocolDataUnit(), txPowerW);
+                m_phyTxBeginTrace(mpdu->GetProtocolDataUnit(), txPower);
             }
         }
     }
 }
 
 void
-WifiPhy::NotifyTxEnd(WifiConstPsduMap psdus)
+WifiPhy::NotifyTxEnd(const WifiConstPsduMap& psdus)
 {
     if (!m_phyTxEndTrace.IsEmpty())
     {
@@ -1657,7 +1690,7 @@
 
 void
 WifiPhy::NotifyMonitorSniffRx(Ptr<const WifiPsdu> psdu,
-                              uint16_t channelFreqMhz,
+                              MHz_u channelFreq,
                               WifiTxVector txVector,
                               SignalNoiseDbm signalNoise,
                               std::vector<bool> statusPerMpdu,
@@ -1680,7 +1713,7 @@
                 if (statusPerMpdu.at(i)) // packet received without error, hand over to sniffer
                 {
                     m_phyMonitorSniffRxTrace(psdu->GetAmpduSubframe(i),
-                                             channelFreqMhz,
+                                             static_cast<uint16_t>(channelFreq),
                                              txVector,
                                              aMpdu,
                                              signalNoise,
@@ -1700,7 +1733,7 @@
         {
             aMpdu.type = NORMAL_MPDU;
             m_phyMonitorSniffRxTrace(psdu->GetPacket(),
-                                     channelFreqMhz,
+                                     static_cast<uint16_t>(channelFreq),
                                      txVector,
                                      aMpdu,
                                      signalNoise,
@@ -1711,7 +1744,7 @@
 
 void
 WifiPhy::NotifyMonitorSniffTx(Ptr<const WifiPsdu> psdu,
-                              uint16_t channelFreqMhz,
+                              MHz_u channelFreq,
                               WifiTxVector txVector,
                               uint16_t staId)
 {
@@ -1729,7 +1762,7 @@
             for (size_t i = 0; i < nMpdus;)
             {
                 m_phyMonitorSniffTxTrace(psdu->GetAmpduSubframe(i),
-                                         channelFreqMhz,
+                                         channelFreq,
                                          txVector,
                                          aMpdu,
                                          staId);
@@ -1744,7 +1777,7 @@
         if (!m_phyMonitorSniffTxTrace.IsEmpty())
         {
             aMpdu.type = NORMAL_MPDU;
-            m_phyMonitorSniffTxTrace(psdu->GetPacket(), channelFreqMhz, txVector, aMpdu, staId);
+            m_phyMonitorSniffTxTrace(psdu->GetPacket(), channelFreq, txVector, aMpdu, staId);
         }
     }
 }
@@ -1763,7 +1796,7 @@
 }
 
 void
-WifiPhy::Send(WifiConstPsduMap psdus, const WifiTxVector& txVector)
+WifiPhy::Send(const WifiConstPsduMap& psdus, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << psdus << txVector);
     /* Transmission can happen if:
@@ -1813,9 +1846,9 @@
         return;
     }
 
-    Time txDuration = CalculateTxDuration(psdus, txVector, GetPhyBand());
+    const auto txDuration = CalculateTxDuration(psdus, txVector, GetPhyBand());
 
-    bool noEndPreambleDetectionEvent = true;
+    auto noEndPreambleDetectionEvent = true;
     for (const auto& [mc, entity] : m_phyEntities)
     {
         noEndPreambleDetectionEvent =
@@ -1848,21 +1881,20 @@
         return;
     }
 
-    Ptr<WifiPpdu> ppdu =
-        GetPhyEntity(txVector.GetModulationClass())->BuildPpdu(psdus, txVector, txDuration);
+    auto ppdu = GetPhyEntity(txVector.GetModulationClass())->BuildPpdu(psdus, txVector, txDuration);
     m_previouslyRxPpduUid = UINT64_MAX; // reset (after creation of PPDU) to use it only once
 
-    double txPowerW = DbmToW(GetTxPowerForTransmission(ppdu) + GetTxGain());
-    NotifyTxBegin(psdus, txPowerW);
+    const auto txPower = DbmToW(GetTxPowerForTransmission(ppdu) + GetTxGain());
+    NotifyTxBegin(psdus, txPower);
     if (!m_phyTxPsduBeginTrace.IsEmpty())
     {
-        m_phyTxPsduBeginTrace(psdus, txVector, txPowerW);
+        m_phyTxPsduBeginTrace(psdus, txVector, txPower);
     }
     for (const auto& psdu : psdus)
     {
         NotifyMonitorSniffTx(psdu.second, GetFrequency(), txVector, psdu.first);
     }
-    m_state->SwitchToTx(txDuration, psdus, GetPowerDbm(txVector.GetTxPowerLevel()), txVector);
+    m_state->SwitchToTx(txDuration, psdus, GetPower(txVector.GetTxPowerLevel()), txVector);
 
     if (m_wifiRadioEnergyModel &&
         m_wifiRadioEnergyModel->GetMaximumTimeInState(WifiPhyState::TX) < txDuration)
@@ -2229,7 +2261,7 @@
 }
 
 void
-WifiPhy::ResetCca(bool powerRestricted, double txPowerMaxSiso, double txPowerMaxMimo)
+WifiPhy::ResetCca(bool powerRestricted, dBm_u txPowerMaxSiso, dBm_u txPowerMaxMimo)
 {
     NS_LOG_FUNCTION(this << powerRestricted << txPowerMaxSiso << txPowerMaxMimo);
     // This method might be called multiple times when receiving TB PPDUs with a BSS color
@@ -2251,40 +2283,40 @@
     }
 }
 
-double
+dBm_u
 WifiPhy::GetTxPowerForTransmission(Ptr<const WifiPpdu> ppdu) const
 {
     NS_LOG_FUNCTION(this << m_powerRestricted << ppdu);
     const auto& txVector = ppdu->GetTxVector();
     // Get transmit power before antenna gain
-    double txPowerDbm;
+    dBm_u txPower;
     if (!m_powerRestricted)
     {
-        txPowerDbm = GetPowerDbm(txVector.GetTxPowerLevel());
+        txPower = GetPower(txVector.GetTxPowerLevel());
     }
     else
     {
         if (txVector.GetNssMax() > 1 || txVector.GetNssTotal() > 1)
         {
-            txPowerDbm = std::min(m_txPowerMaxMimo, GetPowerDbm(txVector.GetTxPowerLevel()));
+            txPower = std::min(m_txPowerMaxMimo, GetPower(txVector.GetTxPowerLevel()));
         }
         else
         {
-            txPowerDbm = std::min(m_txPowerMaxSiso, GetPowerDbm(txVector.GetTxPowerLevel()));
+            txPower = std::min(m_txPowerMaxSiso, GetPower(txVector.GetTxPowerLevel()));
         }
     }
 
     // Apply power density constraint on EIRP
-    uint16_t channelWidth = ppdu->GetTxChannelWidth();
-    double txPowerDbmPerMhz =
-        (txPowerDbm + GetTxGain()) - RatioToDb(channelWidth); // account for antenna gain since EIRP
-    NS_LOG_INFO("txPowerDbm=" << txPowerDbm << " with txPowerDbmPerMhz=" << txPowerDbmPerMhz
-                              << " over " << channelWidth << " MHz");
-    txPowerDbm = std::min(txPowerDbmPerMhz, m_powerDensityLimit) + RatioToDb(channelWidth);
-    txPowerDbm -= GetTxGain(); // remove antenna gain since will be added right afterwards
-    NS_LOG_INFO("txPowerDbm=" << txPowerDbm
-                              << " after applying m_powerDensityLimit=" << m_powerDensityLimit);
-    return txPowerDbm;
+    const auto channelWidth = ppdu->GetTxChannelWidth();
+    dBm_per_MHz_u txPowerDbmPerMhz =
+        (txPower + GetTxGain()) - RatioToDb(channelWidth); // account for antenna gain since EIRP
+    NS_LOG_INFO("txPower=" << txPower << "dBm with txPowerDbmPerMhz=" << txPowerDbmPerMhz
+                           << " over " << channelWidth << " MHz");
+    txPower = std::min(txPowerDbmPerMhz, m_powerDensityLimit) + RatioToDb(channelWidth);
+    txPower -= GetTxGain(); // remove antenna gain since will be added right afterwards
+    NS_LOG_INFO("txPower=" << txPower
+                           << "dBm after applying m_powerDensityLimit=" << m_powerDensityLimit);
+    return txPower;
 }
 
 Ptr<const WifiPsdu>
